#include "plg.h"
#define WIN_WIDTH  7.0
#define WIN_HEIGHT 4.0

/* 20 Jun '03  note: all semfile stuff pulled for 1.3 */

main()
{
int stat;
char response[500];
double GL_rand();
int i;
char color[12];
char shape[12];
char symcode[20];

getgui_init( "GETGUI Demonstration", WIN_WIDTH, WIN_HEIGHT, 100, 0 );
/* getgui_set( "semfile", "semfile1" ); */

TOP:

getgui_buttons( "Welcome to GETGUI-LIB, \n\
a simple set of 10 C functions or so\n\
that allow programs to present \n\
buttons and key entry boxes\n\
and get user input.\n\
As opposed to most other GUI environments,\n\
GETGUI is procedural rather than event-driven,\n\
and hence is much easier to set up for many\n\
procedural applications.", "Do the demo,Quit", response );

if( strcmp( response, "Quit" )==0 ) exit( 0 );

/* getgui_set( "textalign", "left" ); */
getgui_buttons( "This is an example of getgui_buttons\n\
(a prompt with buttons).\n\
Click on any button..", "Red,Yellow,Blue,Unknown", response );
printf( "%s\n", response ); fflush( stdout );

getgui_buttons( "You can also have \n\
two rows of buttons...", "Happy,Grumpy,Sleepy,Dopey,\nDoc,Sneezy,Sleezy", response );
printf( "%s\n", response ); fflush( stdout );

getgui_keyinput( "Here is an example of getgui_keyinput.\n\
Text may be typed in, or a button pressed.", "", 20, "OK,Cancel", response );
printf( "%s\n", response ); fflush( stdout );

getgui_set( "passwordmode", "1" );
getgui_keyinput( "Test of getgui_keyinput\nin password mode:", "", 8, "", response );
getgui_set( "passwordmode", "0" );
printf( "%s\n", response ); fflush( stdout );

strcpy( response, "" );
getgui_editbox( "This is an example of getgui_editbox.", 500, "everyline", "OK,Cancel", response );
printf( "%s\n", response ); fflush( stdout );

getgui_progress( "Here is a demonstration of getgui_progress()\n\
and getgui_poll().  getgui_progress puts a message on\n\
the screen then returns to allow your program\n\
to do other work.  Your program then calls \n\
getgui_poll() at regular intervals to see if\n\
user pressed a button.\n\
\n\
Press Stop when ready to continue..", "Stop" );


i = 0;
while( 1 ) {
	if( getgui_poll( response )) break;

	/* the following code illustrates how a semaphore file may be checked in
	   an async loop.. */
	if( i >= 100 )  { 
		/* getgui_semfile(); */ /* check for presence of semaphore file; if present
				    execute commands embedded therein */
		i = 0;
		}
	i++;  /* maintain i so that semfile is checked only once every several seconds */
	/* end of semaphore file code.. */

	usleep( 50000 ); /* loop delay, equiv. to 20 cycles per second */
	}

printf( "%s\n", response ); fflush( stdout );

getgui_progress( "Example using\ngetgui_key.\nPress various keys, OK to quit", "OK" );
while( 1 ) {
	getgui_key( response );
	printf( "key = %s\n", response );
	fflush( stdout );
	if( strcmp( response, ".!char13" )==0 || strcmp( response, "OK" )==0 ) break;
	}

getgui_set( "textsize", "8" );
getgui_set( "textalign", "L" );

getgui_buttons( "Text size and alignment may be \n\
controlled on the fly.  This\n\
should be 8 point left aligned.\n\
Left-aligned may be preferable\n\
for tabular displays such as this:\n\
-------    ------   -------   --------\n\
ABCDEF       20       30.5    10/29/98", "OK", response );

getgui_set( "textsize", "" ); /* restore to default (12 pt) */
getgui_set( "textalign", "" );    /* restore to default (centered) */

#ifdef SUSPEND
getgui_buttons( "The red diamond in the upper left is an \n\
example of a status indicator.  It is driven by\n\
a file (./semfile1 in this case), which can \n\
be updated by any other process running on\n\
the system.  This allows the GETGUI window to \n\
include status indicators that respond to external\n\
events.", "OK", response );
getgui_set( "textsize", "" );

#endif

getgui_buttons( "Do you want to see the\nanimation sequence?", "Yes,No", response );

if( strcmp( response, "Yes" )== 0 ) {
	strcpy( shape, "1a" );
	strcpy( color, "red" );
	/* loop on user selection.. */
	while( 1 ) {
		getgui_progress( "Animation sequence..", 
			"Color Change,Shape Change,STOP" );
		sprintf( symcode, "sym%s%s", shape, color );
		Elinetype( 0, 2.0, 1.0 );
		i = 0;
		while( 1 ) {
			getgui_poll( response );

			if( i == 0 )  /* getgui_semfile() */ ; /* check semaphore file */
			i++;  
			if( i > 100 ) i = 0;

			if( strcmp( response, "STOP" )==0 ) break;
			else if( strcmp( response, "Color Change" )==0 ) {
				getgui_progressclear();
				getgui_buttons( "Select color", 
					"red,blue,yellow,purple,orange,green", color );
				break;
				}
			else if( strcmp( response, "Shape Change" )==0 ) {
				getgui_progressclear();
				getgui_buttons( "Select shape", 
					"Triangle,Diamond,Square,Pentagon,Circle", shape);
				if( strcmp( shape, "Triangle" )==0) strcpy( shape, "1a" );
				else if( strcmp( shape, "Diamond" )==0) strcpy( shape, "3a" );
				else if( strcmp( shape, "Square" )==0) strcpy( shape, "4a" );
				else if( strcmp( shape, "Pentagon" )==0) strcpy( shape, "5a" );
				else if( strcmp( shape, "Circle" )==0) strcpy( shape, "6a" );
				break;
				}
			Emark( GL_rand() * WIN_WIDTH, GL_rand() * (0.15 * WIN_HEIGHT), 
				symcode, GL_rand() );
			usleep( 50000 ); /* microseconds; equiv to 20 cycles per second */
			}
		Enormline();
		if( strcmp( response, "STOP" )==0 ) break;
		}
	}
getgui_buttons( "End of demo.", "Quit,Repeat", response );
if( strcmp( response, "Repeat" )==0 ) goto TOP;
}
